=== debian/changelog ===
cvs-conf (0.0.1-5) unstable; urgency=low

  * fix a typo in package description (Closes: #142471)  

 -- Sebastien J. Gross <sjg@debian.org>  Fri, 12 Apr 2002 10:11:52 +0200

cvs-conf (0.0.1-4) unstable; urgency=low

  * Fix pserver connexion bug (Closes: #141510) 

 -- Sebastien J. Gross <sjg@debian.org>  Sun,  7 Apr 2002 19:06:39 +0200

cvs-conf (0.0.1-3) unstable; urgency=low

  * postint had been rewritten 

 -- Sebastien J. Gross <sjg@debian.org>  Fri,  5 Apr 2002 18:13:50 +0200

cvs-conf (0.0.1-2) unstable; urgency=low

  * Downgrade some software version to be compatible with Woody.

 -- Sebastien J. Gross <sjg@debian.org>  Sat, 30 Mar 2002 13:44:23 +0100

cvs-conf (0.0.1-1) unstable; urgency=low

  * Initial Release (Closes: #140349).

 -- Sebastien J. Gross <sjg@debian.org>  Wed, 27 Mar 2002 18:12:26 +0100
