=== debian/control ===
Source: cvs-conf
Section: utils
Priority: optional
Maintainer: Sebastien J. Gross <sjg@debian.org>
Build-Depends-Indep: debhelper (>> 3.0.0)
Standards-Version: 3.5.2

Package: cvs-conf
Architecture: all
Depends: ${shlibs:Depends}, cvs (>= 1.10.7), diff (>= 2.7), patch (>= 2.5), stat (>= 3.2), grep (>= 2.4.2), make (>= 3.79), debconf (>= 1.0.25) 
Description: Manage your configuration via CVS
 cvs-conf allows users to manage their configuration files using
 CVS. On the server, a global configuration project is created and
 each host is a part of the global configuration. The advantage of
 cvs-conf is its capacity to restore all file permissions when
 installing files (user, group and rwx).
